[![npm version](https://img.shields.io/npm/v/octo-drive.svg?style=flat-square)](https://www.npmjs.com/package/octo-drive) [![Build Status](https://img.shields.io/travis/linuxenko/octo-drive?style=flat-square)](https://travis-ci.org/linuxenko/octo-drive)

<br>

[![logo](media/octo-drive-logo.png)](https://github.com/linuxenko/octo-drive)


`octo-drive` helps you turn github repository into enctypted filesystem.

### Features

  * Encrypts every file with your password
  * Encrypts filesystem metadata
  * Encrypts filenames inside of repository
  * Each file is encrypted repository file (reduce network requests)
  * Uses encrypted local cache to make it a bit faster
  * Fast enough for both, download and upload

### Usage

Dependencies install:

```
sudo apt-get install libfuse-dev
```

How `octo-drive` itself ?

```
npm install -g octo-drive
```

How to use ?

```
octo-drive githubuser/myrepository ~/drive
```

It will mount repository `mysrepository` of `githubuser` into `~/drive`

After this, it may ask some questions, such as:

  * Do you want to authorize using github token ?
  * Or you would like to use user/password for your account ?

Then it asks for `drive secret`, all the data will be encoded
using this `secret`.

### Environment variables

There is a couple of `ENV`ironment variables you may use to avoid
typing your secrets every time you want to mount the filesystem:

`export OCTODRIVE_TOKEN=...`
or
`export OCTODRIVE_USER=...`
`export OCTODRIVE_PASS=...`
and
`export OCTODRIVE_SECRET=...`
`export OCTODRIVE_BRANCH=...`

Please note that passwords and secrets are plaintext. The simplest way to hide
them inside of a shell script on an encrypted, local filesystem.

### Is it really secure ?

I don't know, tell me please if you have something to say about it.

### Bugz..z.. Features !

`octo-drive` can handle different filesystems for just different secrets ;)

### Changelog

*0.3.4*
  * Dependencies update

*0.3.3*

  * `OCTODRIVE_BRANCH` env support (to avoid repository activity logging)


### License

BSD
